/***************************************************************************
                          auriferous.cpp  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "auriferous.h"
#include "resources.h"
#include "menu.h"
#include "config.h"
//#include <ClanLib/gl.h>

//here starts the game! :)
Auriferous app;

char *Auriferous::get_title()
{
	return "Auriferous 1.0.1, by funthing";
}

void Auriferous::init_modules()
{
	//setup up Clanlib!
	CL_SetupCore::init();
	//CL_SetupGL::init();
	CL_SetupJPEG::init();
	CL_SetupPNG::init();
	CL_SetupSound::init();
	CL_SetupDisplay::init();

	//init the randomizer
	srand((long)time(NULL));

	//read the configfile
	Config::init();

	//init the resourcemanager
	Resources::init();
}
void Auriferous::deinit_modules()
{
	//write the config to the file
	Config::deinit();

	// mouse must be hidden before calling CL_SetupDisplay::deinit(),
	// otherwise ClanLib segfaults
	CL_MouseCursor::hide();

	//deinit Clanlib!
	CL_SetupJPEG::deinit();
	CL_SetupPNG::deinit();
	CL_SetupDisplay::deinit();
	CL_SetupSound::deinit();
	//CL_SetupGL::deinit();
	CL_SetupCore::deinit();
}

int Auriferous::main(int argc, char** argv)
{
	try
	{
		Auriferous::init_modules();

		CL_Display::set_videomode(1024, 768, 16, Config::get_full_screen());

		//CL_OpenGL::begin_2d();

		CL_MouseCursor::hide();

		CL_Display::clear_display();
		Resources::Cgfont()->print_center(512, 334, "Loading...");
		CL_Display::flip_display();	

		Resources::load_all();

		if(Config::get_intro()==true)
		intro();

		menu=new Menu(this);
		menu->start();

		delete menu;

		//CL_OpenGL::end_2d();

		Auriferous::deinit_modules();
	}
	catch(CL_Error err)
	{
		cout<<endl<<"Something went wrong! wait for a bugfix!"<<endl;
		cout<<err.message<<endl;
		return 255;
	}
}
void Auriferous::intro()
{
	int i=1;
	CL_Surface* sur;
	Resources::Speed()->play();

	while(CL_Keyboard::get_keycode(CL_KEY_ESCAPE) != true)
	{
		CL_Display::clear_display();

		if(i<10)
		sur=CL_JPEGProvider::create(Resources::datapath+"pics/menu/intro/intro000"+(CL_String)(i)+".jpg", NULL);
		else if(i<100)
		{
		sur=CL_JPEGProvider::create(Resources::datapath+"pics/menu/intro/intro00"+(CL_String)(i)+".jpg", NULL);
		if(i==75)
		Resources::Speed()->play();
		else if(i==25)
		Resources::Speed()->play();
		}
		else
		sur=CL_JPEGProvider::create(Resources::datapath+"pics/menu/intro/intro0"+(CL_String)(i)+".jpg", NULL);

		sur->put_screen(352, 256);
		if(sur)
		delete sur;
		if(i<135)
		i++;
		else
		break;

		CL_Display::flip_display();			
		CL_System::keep_alive();
	}

	Resources::Teleport()->play();
}
